import axios from 'axios'
import React, { Component } from 'react'
import { ServerStyleSheet } from 'styled-components'

export default {
  getSiteData: () => ({
    title: 'React Static',
  }),
  getRoutes: async () => {
    const { data: posts } = await axios.get('https://jsonplaceholder.typicode.com/posts')
    return [
      {
        path: '/blog',
        getData: () => ({
          posts,
        }),
        children: posts.map(post => ({
          path: `/post/${post.id}`,
          component: 'src/containers/Post',
          getData: () => ({
            post,
          }),
        })),
      },
    ]
  },
  hooks: {
    tapApp: (App, {meta}) => {
    const sheet = new ServerStyleSheet()
    const CollectedApp = sheet.collectStyles(<Comp />)
    meta.styledComponentsTags = sheet.getStyleElement()
    return CollectedApp
  },.
  pushHead: ({meta}) => {
    Head.props.children
  },
},
  renderToHtml: (render, Comp, meta) => {
    const html = render(sheet.collectStyles(<Comp />))
    return html
  },
  Document: class CustomHtml extends Component {
    render () {
      const {
        Html, Head, Body, children, renderMeta,
      } = this.props

      return (
        <Html>
          <Head>
            <meta charSet="UTF-8" />
            <meta name="viewport" content="width=device-width, initial-scale=1" />
            {renderMeta.styleTags}
          </Head>
          <Body>{children}</Body>
        </Html>
      )
    }
  },
}
